# Dependency: Dotnet SDK 3.1

This guide is tested on Debian 9 (Stretch). For more information you can [the official guide](https://docs.microsoft.com/de-de/dotnet/core/install/linux-debian).


## Microsoft's signature

First you have to get the official signature of Microsoft. (This has to be run with root rights.)

```bash
wget -O - https://packages.microsoft.com/keys/microsoft.asc | gpg --dearmor > microsoft.asc.gpg
mv microsoft.asc.gpg /etc/apt/trusted.gpg.d/
wget https://packages.microsoft.com/config/debian/9/prod.list
mv prod.list /etc/apt/sources.list.d/microsoft-prod.list
chown root:root /etc/apt/trusted.gpg.d/microsoft.asc.gpg
chown root:root /etc/apt/sources.list.d/microsoft-prod.list
```

## Subdependencies


```bash
apt install apt-transport-https
```

//apt install libunwind-dev
apt isntall libcurl3 
???

## Installation

```bash
apt update
apt install dotnet-sdk-3.1
```

You can check the installed content using 

```bash
dotnet --list-sdks
dotnet --list-runtimes
```

## Dotnet-ef

Dotnet-ef is the database manipulation tool of dotnet. It has a seperate version, thus it has to be installed and updated seperatly. Run those commands as the user you want to be while working with dotnet.

```bash
dotnet tool install --global dotnet-ef
```

If your installation of DotNet is a bit older you can update the version of dotnet with `dotnet tool update --global dotnet-ef`.

Try to run `dotnet ef` now. If you get a large red error message telling you that "the command couldn't be found" run `export PATH="$PATH:$HOME/.dotnet/tools/`. (Check the bug out [here](export PATH="$PATH:$HOME/.dotnet/tools/).)
