# Dependency: Yarn

## why yarn

we use yarn because npm (currently?) not allows to install **some** packages from github
e.g. https://github.com/janisdd/brace
error:

```bash
npm ERR! code ENOPACKAGEJSON
npm ERR! package.json Non-registry package missing package.json: git+https://github.com/janisdd/brace.git.
npm ERR! package.json npm can't find a package.json file in your current directory.
```

## Official Source

You *can* grab and install Yarn from the [official source](https://classic.yarnpkg.com/en/docs/install#debian-stable). 

## Installation Guide for Debian 9 (Stretch)

First, the word `yarn` links to another package, `cmdtest`. It's a completely differenct package, in a different language, for a different purpose. It is *not* a replacement for Yarn. Make sure this one isn't installed! (For example with `apt remove cmdtest`. If you keep it there could be problematic interactions.)

You have to install the dependency `apt install apt-transport-https`. For unknown reasons, it isn't automatically installed while installing Yarn.

Following [the official guide](https://classic.yarnpkg.com/en/docs/install#debian-stable):

1. Adding the repository

```bash
curl -sL https://dl.yarnpkg.com/debian/pubkey.gpg | apt-key add -
echo "deb https://dl.yarnpkg.com/debian/ stable main" | tee /etc/apt/sources.list.d/yarn.list
```

2. Updating

This is important. If you skip this step, you won't be able to install Yarn. (cmdtest will pop up every time you try.)

```bash
apt update
```

3. Install

```bash
apt install yarn
```

Make sure your system doesn't try to install cmdtest. (Read before answering "Yes" to anything, you will be asked before a different package is installed.) If you don't get the right package, try to update, upgrade, and even restart the system, until you get what you need.

