# Testing

## Where to test

For testing you should use a TestServer which exists for that purpose only. In this context it doesn't matter whether "server" means an actual machine or VM or Docker. Maybe you don't even know what you are working on. (Most likely your local admin will give you access to one.)


### How to access

You can login there with `ssh user@server`. Now you have command line access. Most likely there is no gui.

Note: You must have an SSH-key for doing so, and the local admin must have allowed login for that specific user with that specific SSH-key.

It worked if the command line prompt changed.

### Where's the code

Any yapex related code is in `/opt/yapex`. There is one directory for each of the projects. But there isn't all the code! Also, there is no SDK installed on the TestServer. You have to upload prebuilt code.

You should have writing access there, although you will likely not be (and shouldn't be) root. You can override them with new versions of the code.

### How to upload

### backup passwords and settings

First, most likely there is already an instance of whatever you want to test. Copy that "old version" to your home directory. Most likely you will need information from there. That's probably the `appsettings.json` which contains the database connection string and the system salt, but you'll never know what you need until it's too late and you have already deleted it. (That doesn't mean you should save a dozen versions. One is enough normally.)

### upload

The preferred tool is [`scp`](https://www.ssh.com/ssh/scp/).

It's used as `scp [options] src-dir user@server:target-dir`.

For uploading a prebuilt version of the ClientServer use that one: `scp -r ClientServer/src/ClientServer/output/ user@server:/opt/yapex/ClientServer/src/ClientServer/`.


## On Naming (TestServer vs TestRunner)

Don't confuse "TestServer" (a server with the only purpose to set up and test the complete yapex eco system) with the "TestRunner" (one part of that eco system, it runs the "tests" – that means giving input and checking whether the output was correct of a students program).

Oh and for the purpose of confusing everyone completely – no really it's just the original name no one bothered to change – on of the two implementations of a `TestRunner` is called `TestServer`.


## What to test

Since the purpose is to "run yapex" every part has to exist on the server. What means 'running Yapex' in this context? There will usually be services to run an instance of each

* the ClientServer (where the build files from the frontend are within)
* the TestRunner (this runs programs written by the Users, within Yapex, and gives inputs from testcases (those written by users, within Yapex) and compares the outputs from those programs with the 'correct' outputs, given by the testcases. There are two implementations: the `LinexSafeTestRunner` and the `TestServer` (once again – it is not the `TestServer`. It's just an implementation of the `TestRunner` which happens to have the single most confusing name.)


## Trouble Shooting

This won't cover anything that could happen. But it's a good place to begin with.

1. Do the services run? Check their status. That's `systemctl --type=service` (Please note that the status `exited` doesn't necessarily mean anything went wrong.)
2. Check the system log. (In Linux it's `/var/log/syslog/`. You read the last N lines with `tail -N /var/log/syslog`)
3. Compare the settings of whatever component failed to any settings file available. The logs can be quit long. I like to reboot the machine to get "back to the start" since in the beginning any component is checked at least once. Most errors/the biggest errors will be visible there.)

## Visiting Test-Yapex in the Browser

You have to know either Ip address or url of the testserver (the one you connected to with ssh) and on which port the ClientServer runs. (Standard is 8002)

This resolves to the address `ip_or_url:port`. (Yes, that's what has to be typed into the Url-bar of the browser.) If you get a blank page you should try again with `https://`.
